﻿/*
 * Greenshot - a free and open source screenshot tool
 * Copyright (C) 2007-2011  Thomas Braun, Jens Klingen, Robin Krom
 * 
 * For more information see: http://getgreenshot.org/
 * The Greenshot project is hosted on Sourceforge: http://sourceforge.net/projects/greenshot/
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 1 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
using System;
using System.Collections.Generic;
using System.Drawing;

namespace Greenshot.Helpers
{
	public class Colors {
		private Colors() {}
		
		public static bool IsVisible(Color c) {
			return c != null && !c.Equals(Color.Empty) && !c.Equals(Color.Transparent) && c.A > 0;
		}
		
		public static Color Mix(List<Color> colors) {
			int a = 0;
			int r = 0;
			int g = 0;
			int b = 0;
			int count = 0;
			foreach(Color color in colors) {
				if(!color.Equals(Color.Empty)) {
					a += color.A;
					r += color.R;
					g += color.G;
					b += color.B;
					count++;
				}
			}
			if (count==0) {
				return Color.Empty;
			}
			return Color.FromArgb(a/count, r/count, g/count, b/count);
		}
	}
}
